/* Css.c generated by valac 0.38.1, the Vala compiler
 * generated from Css.vala, do not modify */

/*
 * Copyright 2017 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))



#define DRTGTK_CSS_BADGE_DEFAULT "badge-default"
#define DRTGTK_CSS_BADGE_OK "badge-ok"
#define DRTGTK_CSS_BADGE_INFO "badge-info"
#define DRTGTK_CSS_BADGE_WARNING "badge-warning"
#define DRTGTK_CSS_BADGE_ERROR "badge-error"
#define DRTGTK_CSS_CUSTOM_CSS "\n" \
"label.badge-default,  button.badge-default,\n" \
"label.badge-warning,  button.badge-warning,\n" \
"label.badge-error,  button.badge-error,\n" \
"label.badge-ok,  button.badge-ok,\n" \
"label.badge-info,  button.badge-info {\n" \
"\tfont-weight: bold;\n" \
"}\n" \
"label.badge-default,\n" \
"label.badge-ok,\n" \
"label.badge-info,\n" \
"label.badge-warning,\n" \
"label.badge-error {\n" \
"\tborder-radius: 10px;\n" \
"\tpadding: 5px 5px;\n" \
"\tfont-size: 95%;\n" \
"}\n" \
"\n" \
"label.badge-warning,  button.badge-warning {\n" \
"\tbackground: #FFD600;\n" \
"\tcolor: #000000;\n" \
"}\n" \
"button.badge-warning:hover {\n" \
"\tbackground-color: #E7C200;\n" \
"}\n" \
"\n" \
"label.badge-error,  button.badge-error {\n" \
"\tbackground: #FF0000;\n" \
"\tcolor: #FFFFFF;\n" \
"}\n" \
"button.badge-error:hover {\n" \
"\tbackground-color: #C70000;\n" \
"}\n" \
"\n" \
"label.badge-info,  button.badge-info {\n" \
"\tbackground: #5FB0FF;\n" \
"\tcolor: #000000;\n" \
"}\n" \
"button.badge-info:hover {\n" \
"\tbackground-color: #43A2FF;\n" \
"}\n" \
"\n" \
"label.badge-default,  button.badge-default {\n" \
"\tbackground: #BFBFBF;\n" \
"\tcolor: #000000;\n" \
"}\n" \
"button.badge-default:hover {\n" \
"\tbackground-color: #ABABAB;\n" \
"}\n" \
"\n" \
"label.badge-ok,  button.badge-ok {\n" \
"\tbackground: #6FEF6F;\n" \
"\tcolor: #000000;\n" \
"}\n" \
"button.badge-ok:hover {\n" \
"\tbackground-color: #52CA52;\n" \
"}\n" \
"\n"
GtkCssProvider* drtgtk_css_apply_custom_styles (GdkScreen* screen, GError** error);


/**
 * Apply Diorite CSS styles.
 * 
 * Not necessary if {@link Drt.Application} is used.
 */
GtkCssProvider* drtgtk_css_apply_custom_styles (GdkScreen* screen, GError** error) {
	GtkCssProvider* result = NULL;
	GtkCssProvider* provider = NULL;
	GtkCssProvider* _tmp0_;
	GdkScreen* _tmp1_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (screen != NULL, NULL);
	_tmp0_ = gtk_css_provider_new ();
	provider = _tmp0_;
	gtk_css_provider_load_from_data (provider, DRTGTK_CSS_CUSTOM_CSS, (gssize) -1, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (provider);
		return NULL;
	}
	_tmp1_ = screen;
	gtk_style_context_add_provider_for_screen (_tmp1_, (GtkStyleProvider*) provider, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
	result = provider;
	return result;
}



