/* PropertyBinding.c generated by valac 0.38.1, the Vala compiler
 * generated from PropertyBinding.vala, do not modify */

/*
 * Copyright 2014 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gobject/gvaluecollector.h>


#define DRT_TYPE_PROPERTY_BINDING_FLAGS (drt_property_binding_flags_get_type ())

#define DRT_TYPE_PROPERTY_BINDING (drt_property_binding_get_type ())
#define DRT_PROPERTY_BINDING(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRT_TYPE_PROPERTY_BINDING, DrtPropertyBinding))
#define DRT_PROPERTY_BINDING_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRT_TYPE_PROPERTY_BINDING, DrtPropertyBindingClass))
#define DRT_IS_PROPERTY_BINDING(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRT_TYPE_PROPERTY_BINDING))
#define DRT_IS_PROPERTY_BINDING_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRT_TYPE_PROPERTY_BINDING))
#define DRT_PROPERTY_BINDING_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRT_TYPE_PROPERTY_BINDING, DrtPropertyBindingClass))

typedef struct _DrtPropertyBinding DrtPropertyBinding;
typedef struct _DrtPropertyBindingClass DrtPropertyBindingClass;
typedef struct _DrtPropertyBindingPrivate DrtPropertyBindingPrivate;

#define DRT_TYPE_KEY_VALUE_STORAGE (drt_key_value_storage_get_type ())
#define DRT_KEY_VALUE_STORAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRT_TYPE_KEY_VALUE_STORAGE, DrtKeyValueStorage))
#define DRT_IS_KEY_VALUE_STORAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRT_TYPE_KEY_VALUE_STORAGE))
#define DRT_KEY_VALUE_STORAGE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DRT_TYPE_KEY_VALUE_STORAGE, DrtKeyValueStorageIface))

typedef struct _DrtKeyValueStorage DrtKeyValueStorage;
typedef struct _DrtKeyValueStorageIface DrtKeyValueStorageIface;

#define DRT_TYPE_LST (drt_lst_get_type ())
#define DRT_LST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRT_TYPE_LST, DrtLst))
#define DRT_LST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRT_TYPE_LST, DrtLstClass))
#define DRT_IS_LST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRT_TYPE_LST))
#define DRT_IS_LST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRT_TYPE_LST))
#define DRT_LST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRT_TYPE_LST, DrtLstClass))

typedef struct _DrtLst DrtLst;
typedef struct _DrtLstClass DrtLstClass;
enum  {
	DRT_PROPERTY_BINDING_DUMMY_PROPERTY,
	DRT_PROPERTY_BINDING_LAST_PROPERTY
};
static GParamSpec* drt_property_binding_properties[DRT_PROPERTY_BINDING_LAST_PROPERTY];
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _DrtParamSpecPropertyBinding DrtParamSpecPropertyBinding;

typedef enum  {
	DRT_PROPERTY_BINDING_FLAGS_BIDIRECTIONAL = 1 << 0,
	DRT_PROPERTY_BINDING_FLAGS_KEY_TO_PROPERTY = 1 << 1,
	DRT_PROPERTY_BINDING_FLAGS_PROPERTY_TO_KEY = 1 << 2
} DrtPropertyBindingFlags;

struct _DrtPropertyBinding {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DrtPropertyBindingPrivate * priv;
};

struct _DrtPropertyBindingClass {
	GTypeClass parent_class;
	void (*finalize) (DrtPropertyBinding *self);
};

struct _DrtKeyValueStorageIface {
	GTypeInterface parent_iface;
	void (*has_key_async) (DrtKeyValueStorage* self, const gchar* key, GAsyncReadyCallback _callback_, gpointer _user_data_);
	gboolean (*has_key_finish) (DrtKeyValueStorage* self, GAsyncResult* _res_);
	gboolean (*has_key) (DrtKeyValueStorage* self, const gchar* key);
	void (*get_value_async) (DrtKeyValueStorage* self, const gchar* key, GAsyncReadyCallback _callback_, gpointer _user_data_);
	GVariant* (*get_value_finish) (DrtKeyValueStorage* self, GAsyncResult* _res_);
	GVariant* (*get_value) (DrtKeyValueStorage* self, const gchar* key);
	void (*unset_async) (DrtKeyValueStorage* self, const gchar* key, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*unset_finish) (DrtKeyValueStorage* self, GAsyncResult* _res_);
	void (*unset) (DrtKeyValueStorage* self, const gchar* key);
	void (*set_default_value_unboxed_async) (DrtKeyValueStorage* self, const gchar* key, GVariant* value, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*set_default_value_unboxed_finish) (DrtKeyValueStorage* self, GAsyncResult* _res_);
	void (*set_default_value_unboxed) (DrtKeyValueStorage* self, const gchar* key, GVariant* value);
	void (*set_value_unboxed_async) (DrtKeyValueStorage* self, const gchar* key, GVariant* value, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*set_value_unboxed_finish) (DrtKeyValueStorage* self, GAsyncResult* _res_);
	void (*set_value_unboxed) (DrtKeyValueStorage* self, const gchar* key, GVariant* value);
	DrtLst* (*get_property_bindings) (DrtKeyValueStorage* self);
	void (*set_property_bindings) (DrtKeyValueStorage* self, DrtLst* value);
};

struct _DrtPropertyBindingPrivate {
	DrtKeyValueStorage* _storage;
	gchar* _key;
	GObject* _object;
	GParamSpec* _property;
	DrtPropertyBindingFlags _flags;
	gboolean has_gone;
};

struct _DrtParamSpecPropertyBinding {
	GParamSpec parent_instance;
};


static gpointer drt_property_binding_parent_class = NULL;

GType drt_property_binding_flags_get_type (void) G_GNUC_CONST;
gpointer drt_property_binding_ref (gpointer instance);
void drt_property_binding_unref (gpointer instance);
GParamSpec* drt_param_spec_property_binding (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void drt_value_set_property_binding (GValue* value, gpointer v_object);
void drt_value_take_property_binding (GValue* value, gpointer v_object);
gpointer drt_value_get_property_binding (const GValue* value);
GType drt_property_binding_get_type (void) G_GNUC_CONST;
gpointer drt_lst_ref (gpointer instance);
void drt_lst_unref (gpointer instance);
GParamSpec* drt_param_spec_lst (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void drt_value_set_lst (GValue* value, gpointer v_object);
void drt_value_take_lst (GValue* value, gpointer v_object);
gpointer drt_value_get_lst (const GValue* value);
GType drt_lst_get_type (void) G_GNUC_CONST;
GType drt_key_value_storage_get_type (void) G_GNUC_CONST;
#define DRT_PROPERTY_BINDING_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DRT_TYPE_PROPERTY_BINDING, DrtPropertyBindingPrivate))
GObject* drt_property_binding_get_object (DrtPropertyBinding* self);
static void drt_property_binding_gone (DrtPropertyBinding* self, GObject* o);
static void _drt_property_binding_gone_gweak_notify (gpointer self, GObject* object);
DrtKeyValueStorage* drt_property_binding_get_storage (DrtPropertyBinding* self);
DrtPropertyBindingFlags drt_property_binding_get_flags (DrtPropertyBinding* self);
GParamSpec* drt_property_binding_get_property (DrtPropertyBinding* self);
static void drt_property_binding_on_property_changed (DrtPropertyBinding* self, GObject* o, GParamSpec* p);
static void _drt_property_binding_on_property_changed_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static void drt_property_binding_on_key_changed (DrtPropertyBinding* self, const gchar* key, GVariant* old_value);
static void _drt_property_binding_on_key_changed_drt_key_value_storage_changed (DrtKeyValueStorage* _sender, const gchar* key, GVariant* old_value, gpointer self);
DrtPropertyBinding* drt_property_binding_new (DrtKeyValueStorage* storage, const gchar* key, GObject* object, GParamSpec* property, DrtPropertyBindingFlags flags);
DrtPropertyBinding* drt_property_binding_construct (GType object_type, DrtKeyValueStorage* storage, const gchar* key, GObject* object, GParamSpec* property, DrtPropertyBindingFlags flags);
static void drt_property_binding_set_storage (DrtPropertyBinding* self, DrtKeyValueStorage* value);
static void drt_property_binding_set_key (DrtPropertyBinding* self, const gchar* value);
static void drt_property_binding_set_object (DrtPropertyBinding* self, GObject* value);
static void drt_property_binding_set_property (DrtPropertyBinding* self, GParamSpec* value);
static void drt_property_binding_set_flags (DrtPropertyBinding* self, DrtPropertyBindingFlags value);
gchar* drt_property_binding_to_string (DrtPropertyBinding* self);
const gchar* drt_property_binding_get_key (DrtPropertyBinding* self);
void drt_property_binding_update_key (DrtPropertyBinding* self);
static void drt_property_binding_toggle_changed_notify_handler (DrtPropertyBinding* self, gboolean enabled);
void drt_key_value_storage_set_string (DrtKeyValueStorage* self, const gchar* key, const gchar* value);
void drt_key_value_storage_set_bool (DrtKeyValueStorage* self, const gchar* key, gboolean value);
gboolean drt_property_binding_update_property (DrtPropertyBinding* self);
static void drt_property_binding_toggle_property_notify_handler (DrtPropertyBinding* self, gboolean enabled);
gchar* drt_key_value_storage_get_string (DrtKeyValueStorage* self, const gchar* key);
gboolean drt_key_value_storage_get_bool (DrtKeyValueStorage* self, const gchar* key);
DrtPropertyBinding* drt_property_binding_set_default (DrtPropertyBinding* self, GVariant* default_value);
void drt_key_value_storage_set_default_value (DrtKeyValueStorage* self, const gchar* key, GVariant* value);
void drt_key_value_storage_remove_property_binding (DrtKeyValueStorage* self, DrtPropertyBinding* binding);
static void drt_property_binding_finalize (DrtPropertyBinding * obj);


GType drt_property_binding_flags_get_type (void) {
	static volatile gsize drt_property_binding_flags_type_id__volatile = 0;
	if (g_once_init_enter (&drt_property_binding_flags_type_id__volatile)) {
		static const GFlagsValue values[] = {{DRT_PROPERTY_BINDING_FLAGS_BIDIRECTIONAL, "DRT_PROPERTY_BINDING_FLAGS_BIDIRECTIONAL", "bidirectional"}, {DRT_PROPERTY_BINDING_FLAGS_KEY_TO_PROPERTY, "DRT_PROPERTY_BINDING_FLAGS_KEY_TO_PROPERTY", "key-to-property"}, {DRT_PROPERTY_BINDING_FLAGS_PROPERTY_TO_KEY, "DRT_PROPERTY_BINDING_FLAGS_PROPERTY_TO_KEY", "property-to-key"}, {0, NULL, NULL}};
		GType drt_property_binding_flags_type_id;
		drt_property_binding_flags_type_id = g_flags_register_static ("DrtPropertyBindingFlags", values);
		g_once_init_leave (&drt_property_binding_flags_type_id__volatile, drt_property_binding_flags_type_id);
	}
	return drt_property_binding_flags_type_id__volatile;
}


static void _drt_property_binding_gone_gweak_notify (gpointer self, GObject* object) {
	drt_property_binding_gone ((DrtPropertyBinding*) self, object);
}


static void _drt_property_binding_on_property_changed_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	drt_property_binding_on_property_changed ((DrtPropertyBinding*) self, _sender, pspec);
}


static void _drt_property_binding_on_key_changed_drt_key_value_storage_changed (DrtKeyValueStorage* _sender, const gchar* key, GVariant* old_value, gpointer self) {
	drt_property_binding_on_key_changed ((DrtPropertyBinding*) self, key, old_value);
}


DrtPropertyBinding* drt_property_binding_construct (GType object_type, DrtKeyValueStorage* storage, const gchar* key, GObject* object, GParamSpec* property, DrtPropertyBindingFlags flags) {
	DrtPropertyBinding* self = NULL;
	gboolean _tmp0_ = FALSE;
	DrtPropertyBindingFlags _tmp1_;
	DrtKeyValueStorage* _tmp4_;
	const gchar* _tmp5_;
	GObject* _tmp6_;
	GParamSpec* _tmp7_;
	DrtPropertyBindingFlags _tmp8_;
	DrtPropertyBindingFlags _tmp9_;
	DrtPropertyBindingFlags _tmp14_;
	GObject* _tmp16_;
	DrtKeyValueStorage* _tmp17_;
	g_return_val_if_fail (storage != NULL, NULL);
	g_return_val_if_fail (key != NULL, NULL);
	g_return_val_if_fail (object != NULL, NULL);
	g_return_val_if_fail (property != NULL, NULL);
	self = (DrtPropertyBinding*) g_type_create_instance (object_type);
	_tmp1_ = flags;
	if ((_tmp1_ & DRT_PROPERTY_BINDING_FLAGS_PROPERTY_TO_KEY) != 0) {
		DrtPropertyBindingFlags _tmp2_;
		_tmp2_ = flags;
		_tmp0_ = (_tmp2_ & DRT_PROPERTY_BINDING_FLAGS_KEY_TO_PROPERTY) != 0;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		DrtPropertyBindingFlags _tmp3_;
		_tmp3_ = flags;
		flags = _tmp3_ | DRT_PROPERTY_BINDING_FLAGS_BIDIRECTIONAL;
	}
	_tmp4_ = storage;
	drt_property_binding_set_storage (self, _tmp4_);
	_tmp5_ = key;
	drt_property_binding_set_key (self, _tmp5_);
	_tmp6_ = object;
	drt_property_binding_set_object (self, _tmp6_);
	_tmp7_ = property;
	drt_property_binding_set_property (self, _tmp7_);
	_tmp8_ = flags;
	drt_property_binding_set_flags (self, _tmp8_);
	_tmp9_ = flags;
	if ((_tmp9_ & (DRT_PROPERTY_BINDING_FLAGS_BIDIRECTIONAL | DRT_PROPERTY_BINDING_FLAGS_PROPERTY_TO_KEY)) != 0) {
		GObject* _tmp10_;
		GParamSpec* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		_tmp10_ = object;
		_tmp11_ = property;
		_tmp12_ = _tmp11_->name;
		_tmp13_ = g_strconcat ("notify::", _tmp12_, NULL);
		g_signal_connect_after (_tmp10_, _tmp13_, (GCallback) _drt_property_binding_on_property_changed_g_object_notify, self);
		_g_free0 (_tmp13_);
	}
	_tmp14_ = flags;
	if ((_tmp14_ & (DRT_PROPERTY_BINDING_FLAGS_BIDIRECTIONAL | DRT_PROPERTY_BINDING_FLAGS_KEY_TO_PROPERTY)) != 0) {
		DrtKeyValueStorage* _tmp15_;
		_tmp15_ = storage;
		g_signal_connect (_tmp15_, "changed", (GCallback) _drt_property_binding_on_key_changed_drt_key_value_storage_changed, self);
	}
	_tmp16_ = object;
	g_object_weak_ref (_tmp16_, _drt_property_binding_gone_gweak_notify, self);
	_tmp17_ = storage;
	g_object_weak_ref ((GObject*) _tmp17_, _drt_property_binding_gone_gweak_notify, self);
	return self;
}


DrtPropertyBinding* drt_property_binding_new (DrtKeyValueStorage* storage, const gchar* key, GObject* object, GParamSpec* property, DrtPropertyBindingFlags flags) {
	return drt_property_binding_construct (DRT_TYPE_PROPERTY_BINDING, storage, key, object, property, flags);
}


gchar* drt_property_binding_to_string (DrtPropertyBinding* self) {
	gchar* result = NULL;
	gchar* relation = NULL;
	DrtPropertyBindingFlags _tmp0_;
	DrtKeyValueStorage* _tmp7_;
	GType _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	GObject* _tmp12_;
	GType _tmp13_;
	const gchar* _tmp14_;
	GParamSpec* _tmp15_;
	const gchar* _tmp16_;
	GParamSpec* _tmp17_;
	GType _tmp18_;
	const gchar* _tmp19_;
	gchar* _tmp20_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_flags;
	if ((_tmp0_ & DRT_PROPERTY_BINDING_FLAGS_BIDIRECTIONAL) != 0) {
		gchar* _tmp1_;
		_tmp1_ = g_strdup ("<==>");
		_g_free0 (relation);
		relation = _tmp1_;
	} else {
		DrtPropertyBindingFlags _tmp2_;
		_tmp2_ = self->priv->_flags;
		if ((_tmp2_ & DRT_PROPERTY_BINDING_FLAGS_PROPERTY_TO_KEY) != 0) {
			gchar* _tmp3_;
			_tmp3_ = g_strdup ("<==");
			_g_free0 (relation);
			relation = _tmp3_;
		} else {
			DrtPropertyBindingFlags _tmp4_;
			_tmp4_ = self->priv->_flags;
			if ((_tmp4_ & DRT_PROPERTY_BINDING_FLAGS_KEY_TO_PROPERTY) != 0) {
				gchar* _tmp5_;
				_tmp5_ = g_strdup ("==>");
				_g_free0 (relation);
				relation = _tmp5_;
			} else {
				gchar* _tmp6_;
				_tmp6_ = g_strdup ("=?=");
				_g_free0 (relation);
				relation = _tmp6_;
			}
		}
	}
	_tmp7_ = self->priv->_storage;
	_tmp8_ = G_TYPE_FROM_INSTANCE ((GObject*) _tmp7_);
	_tmp9_ = g_type_name (_tmp8_);
	_tmp10_ = self->priv->_key;
	_tmp11_ = relation;
	_tmp12_ = self->priv->_object;
	_tmp13_ = G_TYPE_FROM_INSTANCE (_tmp12_);
	_tmp14_ = g_type_name (_tmp13_);
	_tmp15_ = self->priv->_property;
	_tmp16_ = _tmp15_->name;
	_tmp17_ = self->priv->_property;
	_tmp18_ = _tmp17_->value_type;
	_tmp19_ = g_type_name (_tmp18_);
	_tmp20_ = g_strdup_printf ("%s['%s'] %s %s['%s'] (type %s)", _tmp9_, _tmp10_, _tmp11_, _tmp14_, _tmp16_, _tmp19_);
	result = _tmp20_;
	_g_free0 (relation);
	return result;
}


void drt_property_binding_update_key (DrtPropertyBinding* self) {
	GParamSpec* _tmp0_;
	GType _tmp1_;
	g_return_if_fail (self != NULL);
	drt_property_binding_toggle_changed_notify_handler (self, FALSE);
	_tmp0_ = self->priv->_property;
	_tmp1_ = _tmp0_->value_type;
	if (_tmp1_ == G_TYPE_STRING) {
		gchar* str_value = NULL;
		GObject* _tmp2_;
		GParamSpec* _tmp3_;
		const gchar* _tmp4_;
		DrtKeyValueStorage* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		str_value = NULL;
		_tmp2_ = self->priv->_object;
		_tmp3_ = self->priv->_property;
		_tmp4_ = _tmp3_->name;
		g_object_get (_tmp2_, _tmp4_, &str_value, NULL, NULL);
		_tmp5_ = self->priv->_storage;
		_tmp6_ = self->priv->_key;
		_tmp7_ = str_value;
		drt_key_value_storage_set_string (_tmp5_, _tmp6_, _tmp7_);
		_g_free0 (str_value);
	} else {
		GParamSpec* _tmp8_;
		GType _tmp9_;
		_tmp8_ = self->priv->_property;
		_tmp9_ = _tmp8_->value_type;
		if (_tmp9_ == G_TYPE_BOOLEAN) {
			gboolean value = FALSE;
			GObject* _tmp10_;
			GParamSpec* _tmp11_;
			const gchar* _tmp12_;
			DrtKeyValueStorage* _tmp13_;
			const gchar* _tmp14_;
			gboolean _tmp15_;
			value = FALSE;
			_tmp10_ = self->priv->_object;
			_tmp11_ = self->priv->_property;
			_tmp12_ = _tmp11_->name;
			g_object_get (_tmp10_, _tmp12_, &value, NULL, NULL);
			_tmp13_ = self->priv->_storage;
			_tmp14_ = self->priv->_key;
			_tmp15_ = value;
			drt_key_value_storage_set_bool (_tmp13_, _tmp14_, _tmp15_);
		} else {
			gchar* _tmp16_;
			gchar* _tmp17_;
			_tmp16_ = drt_property_binding_to_string (self);
			_tmp17_ = _tmp16_;
			g_critical ("PropertyBinding.vala:123: Unsupported type for property binding. %s.", _tmp17_);
			_g_free0 (_tmp17_);
		}
	}
	drt_property_binding_toggle_changed_notify_handler (self, TRUE);
}


gboolean drt_property_binding_update_property (DrtPropertyBinding* self) {
	gboolean result = FALSE;
	gboolean _result_ = FALSE;
	GParamSpec* _tmp0_;
	GType _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	drt_property_binding_toggle_property_notify_handler (self, FALSE);
	_result_ = FALSE;
	_tmp0_ = self->priv->_property;
	_tmp1_ = _tmp0_->value_type;
	if (_tmp1_ == G_TYPE_STRING) {
		gchar* str_value = NULL;
		GObject* _tmp2_;
		GParamSpec* _tmp3_;
		const gchar* _tmp4_;
		gchar* new_str_value = NULL;
		DrtKeyValueStorage* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		str_value = NULL;
		_tmp2_ = self->priv->_object;
		_tmp3_ = self->priv->_property;
		_tmp4_ = _tmp3_->name;
		g_object_get (_tmp2_, _tmp4_, &str_value, NULL, NULL);
		_tmp5_ = self->priv->_storage;
		_tmp6_ = self->priv->_key;
		_tmp7_ = drt_key_value_storage_get_string (_tmp5_, _tmp6_);
		new_str_value = _tmp7_;
		_tmp8_ = str_value;
		_tmp9_ = new_str_value;
		if (g_strcmp0 (_tmp8_, _tmp9_) != 0) {
			GObject* _tmp10_;
			GParamSpec* _tmp11_;
			const gchar* _tmp12_;
			const gchar* _tmp13_;
			_tmp10_ = self->priv->_object;
			_tmp11_ = self->priv->_property;
			_tmp12_ = _tmp11_->name;
			_tmp13_ = new_str_value;
			g_object_set (_tmp10_, _tmp12_, _tmp13_, NULL, NULL);
			_result_ = TRUE;
		}
		_g_free0 (new_str_value);
		_g_free0 (str_value);
	} else {
		GParamSpec* _tmp14_;
		GType _tmp15_;
		_tmp14_ = self->priv->_property;
		_tmp15_ = _tmp14_->value_type;
		if (_tmp15_ == G_TYPE_BOOLEAN) {
			gboolean value = FALSE;
			GObject* _tmp16_;
			GParamSpec* _tmp17_;
			const gchar* _tmp18_;
			gboolean new_value = FALSE;
			DrtKeyValueStorage* _tmp19_;
			const gchar* _tmp20_;
			gboolean _tmp21_;
			gboolean _tmp22_;
			gboolean _tmp23_;
			value = FALSE;
			_tmp16_ = self->priv->_object;
			_tmp17_ = self->priv->_property;
			_tmp18_ = _tmp17_->name;
			g_object_get (_tmp16_, _tmp18_, &value, NULL, NULL);
			_tmp19_ = self->priv->_storage;
			_tmp20_ = self->priv->_key;
			_tmp21_ = drt_key_value_storage_get_bool (_tmp19_, _tmp20_);
			new_value = _tmp21_;
			_tmp22_ = value;
			_tmp23_ = new_value;
			if (_tmp22_ != _tmp23_) {
				GObject* _tmp24_;
				GParamSpec* _tmp25_;
				const gchar* _tmp26_;
				gboolean _tmp27_;
				_tmp24_ = self->priv->_object;
				_tmp25_ = self->priv->_property;
				_tmp26_ = _tmp25_->name;
				_tmp27_ = new_value;
				g_object_set (_tmp24_, _tmp26_, _tmp27_, NULL, NULL);
				_result_ = TRUE;
			}
		} else {
			gchar* _tmp28_;
			gchar* _tmp29_;
			_tmp28_ = drt_property_binding_to_string (self);
			_tmp29_ = _tmp28_;
			g_critical ("PropertyBinding.vala:158: Unsupported type for property binding. %s.", _tmp29_);
			_g_free0 (_tmp29_);
		}
	}
	drt_property_binding_toggle_property_notify_handler (self, TRUE);
	result = _result_;
	return result;
}


/**
 * Set default value of the associated key.
 * 
 * Useful for chaining
 * 
 * {{{
 * binding.set_default(true).update_property()
 * }}}
 * 
 * @param default_value    default value to set
 * @return self
 */
static gpointer _drt_property_binding_ref0 (gpointer self) {
	return self ? drt_property_binding_ref (self) : NULL;
}


DrtPropertyBinding* drt_property_binding_set_default (DrtPropertyBinding* self, GVariant* default_value) {
	DrtPropertyBinding* result = NULL;
	DrtKeyValueStorage* _tmp0_;
	const gchar* _tmp1_;
	GVariant* _tmp2_;
	DrtPropertyBinding* _tmp3_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_storage;
	_tmp1_ = self->priv->_key;
	_tmp2_ = default_value;
	drt_key_value_storage_set_default_value (_tmp0_, _tmp1_, _tmp2_);
	_tmp3_ = _drt_property_binding_ref0 (self);
	result = _tmp3_;
	return result;
}


static void drt_property_binding_toggle_property_notify_handler (DrtPropertyBinding* self, gboolean enabled) {
	guint signal_id = 0U;
	GQuark detail = 0U;
	GParamSpec* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	guint _tmp4_ = 0U;
	GQuark _tmp5_ = 0U;
	gboolean _tmp6_;
	gboolean _tmp7_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_property;
	_tmp1_ = _tmp0_->name;
	_tmp2_ = g_strconcat ("notify::", _tmp1_, NULL);
	_tmp3_ = _tmp2_;
	_tmp6_ = g_signal_parse_name (_tmp3_, G_TYPE_OBJECT, &_tmp4_, &_tmp5_, TRUE);
	signal_id = _tmp4_;
	detail = _tmp5_;
	g_return_if_fail (_tmp6_);
	_g_free0 (_tmp3_);
	_tmp7_ = enabled;
	if (_tmp7_) {
		GObject* _tmp8_;
		guint _tmp9_;
		GQuark _tmp10_;
		_tmp8_ = self->priv->_object;
		_tmp9_ = signal_id;
		_tmp10_ = detail;
		g_signal_handlers_unblock_matched (_tmp8_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DATA, _tmp9_, _tmp10_, NULL, NULL, self);
	} else {
		GObject* _tmp11_;
		guint _tmp12_;
		GQuark _tmp13_;
		_tmp11_ = self->priv->_object;
		_tmp12_ = signal_id;
		_tmp13_ = detail;
		g_signal_handlers_block_matched (_tmp11_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DATA, _tmp12_, _tmp13_, NULL, NULL, self);
	}
}


static void drt_property_binding_toggle_changed_notify_handler (DrtPropertyBinding* self, gboolean enabled) {
	guint signal_id = 0U;
	guint _tmp0_ = 0U;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp1_ = g_signal_parse_name ("changed", DRT_TYPE_KEY_VALUE_STORAGE, &_tmp0_, NULL, FALSE);
	signal_id = _tmp0_;
	g_return_if_fail (_tmp1_);
	_tmp2_ = enabled;
	if (_tmp2_) {
		DrtKeyValueStorage* _tmp3_;
		guint _tmp4_;
		_tmp3_ = self->priv->_storage;
		_tmp4_ = signal_id;
		g_signal_handlers_unblock_matched (_tmp3_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DATA, _tmp4_, (GQuark) 0, NULL, NULL, self);
	} else {
		DrtKeyValueStorage* _tmp5_;
		guint _tmp6_;
		_tmp5_ = self->priv->_storage;
		_tmp6_ = signal_id;
		g_signal_handlers_block_matched (_tmp5_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DATA, _tmp6_, (GQuark) 0, NULL, NULL, self);
	}
}


static void drt_property_binding_on_property_changed (DrtPropertyBinding* self, GObject* o, GParamSpec* p) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (o != NULL);
	g_return_if_fail (p != NULL);
	drt_property_binding_update_key (self);
}


static void drt_property_binding_on_key_changed (DrtPropertyBinding* self, const gchar* key, GVariant* old_value) {
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (key != NULL);
	_tmp0_ = key;
	_tmp1_ = self->priv->_key;
	if (g_strcmp0 (_tmp0_, _tmp1_) == 0) {
		drt_property_binding_update_property (self);
	}
}


static void drt_property_binding_gone (DrtPropertyBinding* self, GObject* o) {
	GObject* _tmp0_;
	GObject* _tmp1_;
	GObject* _tmp3_;
	DrtKeyValueStorage* _tmp4_;
	DrtKeyValueStorage* _tmp6_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (o != NULL);
	self->priv->has_gone = TRUE;
	_tmp0_ = o;
	_tmp1_ = self->priv->_object;
	if (_tmp0_ != _tmp1_) {
		GObject* _tmp2_;
		_tmp2_ = self->priv->_object;
		g_object_weak_unref (_tmp2_, _drt_property_binding_gone_gweak_notify, self);
	}
	_tmp3_ = o;
	_tmp4_ = self->priv->_storage;
	if (_tmp3_ != _tmp4_) {
		DrtKeyValueStorage* _tmp5_;
		_tmp5_ = self->priv->_storage;
		g_object_weak_unref ((GObject*) _tmp5_, _drt_property_binding_gone_gweak_notify, self);
	}
	_tmp6_ = self->priv->_storage;
	if (_tmp6_ != NULL) {
		DrtKeyValueStorage* _tmp7_;
		_tmp7_ = self->priv->_storage;
		drt_key_value_storage_remove_property_binding (_tmp7_, self);
	}
}


DrtKeyValueStorage* drt_property_binding_get_storage (DrtPropertyBinding* self) {
	DrtKeyValueStorage* result;
	DrtKeyValueStorage* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_storage;
	result = _tmp0_;
	return result;
}


static void drt_property_binding_set_storage (DrtPropertyBinding* self, DrtKeyValueStorage* value) {
	DrtKeyValueStorage* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_storage = _tmp0_;
}


const gchar* drt_property_binding_get_key (DrtPropertyBinding* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_key;
	result = _tmp0_;
	return result;
}


static void drt_property_binding_set_key (DrtPropertyBinding* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_key);
	self->priv->_key = _tmp1_;
}


GObject* drt_property_binding_get_object (DrtPropertyBinding* self) {
	GObject* result;
	GObject* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_object;
	result = _tmp0_;
	return result;
}


static void drt_property_binding_set_object (DrtPropertyBinding* self, GObject* value) {
	GObject* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_object = _tmp0_;
}


GParamSpec* drt_property_binding_get_property (DrtPropertyBinding* self) {
	GParamSpec* result;
	GParamSpec* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_property;
	result = _tmp0_;
	return result;
}


static void drt_property_binding_set_property (DrtPropertyBinding* self, GParamSpec* value) {
	GParamSpec* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_property = _tmp0_;
}


DrtPropertyBindingFlags drt_property_binding_get_flags (DrtPropertyBinding* self) {
	DrtPropertyBindingFlags result;
	DrtPropertyBindingFlags _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_flags;
	result = _tmp0_;
	return result;
}


static void drt_property_binding_set_flags (DrtPropertyBinding* self, DrtPropertyBindingFlags value) {
	DrtPropertyBindingFlags _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_flags = _tmp0_;
}


static void drt_value_property_binding_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void drt_value_property_binding_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		drt_property_binding_unref (value->data[0].v_pointer);
	}
}


static void drt_value_property_binding_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = drt_property_binding_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer drt_value_property_binding_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* drt_value_property_binding_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		DrtPropertyBinding * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = drt_property_binding_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* drt_value_property_binding_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	DrtPropertyBinding ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = drt_property_binding_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* drt_param_spec_property_binding (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	DrtParamSpecPropertyBinding* spec;
	g_return_val_if_fail (g_type_is_a (object_type, DRT_TYPE_PROPERTY_BINDING), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer drt_value_get_property_binding (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DRT_TYPE_PROPERTY_BINDING), NULL);
	return value->data[0].v_pointer;
}


void drt_value_set_property_binding (GValue* value, gpointer v_object) {
	DrtPropertyBinding * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DRT_TYPE_PROPERTY_BINDING));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DRT_TYPE_PROPERTY_BINDING));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		drt_property_binding_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		drt_property_binding_unref (old);
	}
}


void drt_value_take_property_binding (GValue* value, gpointer v_object) {
	DrtPropertyBinding * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DRT_TYPE_PROPERTY_BINDING));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DRT_TYPE_PROPERTY_BINDING));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		drt_property_binding_unref (old);
	}
}


static void drt_property_binding_class_init (DrtPropertyBindingClass * klass) {
	drt_property_binding_parent_class = g_type_class_peek_parent (klass);
	((DrtPropertyBindingClass *) klass)->finalize = drt_property_binding_finalize;
	g_type_class_add_private (klass, sizeof (DrtPropertyBindingPrivate));
}


static void drt_property_binding_instance_init (DrtPropertyBinding * self) {
	self->priv = DRT_PROPERTY_BINDING_GET_PRIVATE (self);
	self->priv->has_gone = FALSE;
	self->ref_count = 1;
}


static void drt_property_binding_finalize (DrtPropertyBinding * obj) {
	DrtPropertyBinding * self;
	gboolean _tmp0_;
	DrtPropertyBindingFlags _tmp3_;
	DrtPropertyBindingFlags _tmp10_;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DRT_TYPE_PROPERTY_BINDING, DrtPropertyBinding);
	g_signal_handlers_destroy (self);
	_tmp0_ = self->priv->has_gone;
	if (!_tmp0_) {
		GObject* _tmp1_;
		DrtKeyValueStorage* _tmp2_;
		_tmp1_ = self->priv->_object;
		g_object_weak_unref (_tmp1_, _drt_property_binding_gone_gweak_notify, self);
		_tmp2_ = self->priv->_storage;
		g_object_weak_unref ((GObject*) _tmp2_, _drt_property_binding_gone_gweak_notify, self);
		self->priv->has_gone = TRUE;
	}
	_tmp3_ = self->priv->_flags;
	if ((_tmp3_ & (DRT_PROPERTY_BINDING_FLAGS_BIDIRECTIONAL | DRT_PROPERTY_BINDING_FLAGS_PROPERTY_TO_KEY)) != 0) {
		GObject* _tmp4_;
		GParamSpec* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		guint _tmp8_;
		GQuark _tmp9_;
		_tmp4_ = self->priv->_object;
		_tmp5_ = self->priv->_property;
		_tmp6_ = _tmp5_->name;
		_tmp7_ = g_strconcat ("notify::", _tmp6_, NULL);
		g_signal_parse_name (_tmp7_, G_TYPE_OBJECT, &_tmp8_, &_tmp9_, TRUE);
		g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp8_, _tmp9_, NULL, (GCallback) _drt_property_binding_on_property_changed_g_object_notify, self);
		_g_free0 (_tmp7_);
	}
	_tmp10_ = self->priv->_flags;
	if ((_tmp10_ & (DRT_PROPERTY_BINDING_FLAGS_BIDIRECTIONAL | DRT_PROPERTY_BINDING_FLAGS_KEY_TO_PROPERTY)) != 0) {
		DrtKeyValueStorage* _tmp11_;
		guint _tmp12_;
		_tmp11_ = self->priv->_storage;
		g_signal_parse_name ("changed", DRT_TYPE_KEY_VALUE_STORAGE, &_tmp12_, NULL, FALSE);
		g_signal_handlers_disconnect_matched (_tmp11_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp12_, 0, NULL, (GCallback) _drt_property_binding_on_key_changed_drt_key_value_storage_changed, self);
	}
	_g_free0 (self->priv->_key);
}


GType drt_property_binding_get_type (void) {
	static volatile gsize drt_property_binding_type_id__volatile = 0;
	if (g_once_init_enter (&drt_property_binding_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { drt_value_property_binding_init, drt_value_property_binding_free_value, drt_value_property_binding_copy_value, drt_value_property_binding_peek_pointer, "p", drt_value_property_binding_collect_value, "p", drt_value_property_binding_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (DrtPropertyBindingClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) drt_property_binding_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DrtPropertyBinding), 0, (GInstanceInitFunc) drt_property_binding_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType drt_property_binding_type_id;
		drt_property_binding_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DrtPropertyBinding", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&drt_property_binding_type_id__volatile, drt_property_binding_type_id);
	}
	return drt_property_binding_type_id__volatile;
}


gpointer drt_property_binding_ref (gpointer instance) {
	DrtPropertyBinding * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void drt_property_binding_unref (gpointer instance) {
	DrtPropertyBinding * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		DRT_PROPERTY_BINDING_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}



